#ifndef ASTEROIDS_H
#define ASTEROIDS_H

#include "menu.h"
#include "bresenham.h"

extern const menuitem_t menuitem_asteroids;

typedef struct
{
} asteroids_frame_t;

typedef struct 
{
    int8_t x, y;
    uint8_t diam;
} asteroids_explode_t;

#define ASTRO_NUM_SPRITES 16
#define ASTRO_NUM_EXPLODES 5

typedef struct
{
    uint8_t drawid;
    uint8_t drawfirst;
    uint8_t laserid;
    bh_linedraw_t bline;
    bh_polydraw_t bpoly;
    struct
    {
        // onRedraw
        uint8_t next_id;
        // onPixel
        uint8_t id;
        uint8_t pix;
        asteroids_explode_t data[ASTRO_NUM_EXPLODES];
    } explode;
    //motion_t motion[ASTRO_NUM_SPRITES];
    bh_sprite_t sprites[ASTRO_NUM_SPRITES];
} asteroids_t;

#endif // ASTEROIDS_H
