#include <stdio.h>
#include <stdlib.h>

#include "compat/pgmspace.h"
#include "compat/interrupt.h"

#define __AVR_ATmega168__
enum 
{
    PORTA_ID,
    PORTB_ID,
    PORTC_ID,
    PORTD_ID,

    SERPAIN_ID,
    SERPA_ID
};

#include "ports.h"

#include "frame.h"
#include "countdown.h"
#include "menu.h"
#include "main.h"
#include "vektor-zeichen.h"

upixel8_t dac;

beam_t beam;
menu_t menu;

vecfont_t vecfont;

// Eigene Glyphs fr VEKFONT
const uint8_t snake_glyph[] PROGMEM =
{
    // Tabellen-Ende
    VF_UNKNOWN_EXTRA, 1
    , VF_LINE (1,  1,  0, 1, 0)
};

countdown_t volatile count;

void cli (void) {}
void sei (void) {}

char * texxt = "F1234";

void dac_p (void)
{
    dac = reg_pixel;
    printf (" DAC(%d,%d)\n", dac.x, dac.y);
}

static void beam_skip (void)
{
    printf ("skip ");
    FLAGS |= BEAM_SKIP;
}

static void beam_xy (vf_uint_t x, vf_uint_t y)
{
    reg_pixel.x = x;
    reg_pixel.y = y;
    FLAGS |= BEAM_CHANGED;
    printf ("XY[%d,%d] ", reg_pixel.x, reg_pixel.y);
}

void onPixel (void * data)
{
    if (!IS_FLAG (BEAM_LOCKED))
    {
        printf ("init %p ", text);
        vecfont.proportional = 0;
        vecfont.zoom = 1;
        vecfont.text = texxt;
        vecfont.start = (upixel8_t) {100, 100};
        FLAGS |= BEAM_LOCKED;
    }
    
    printf ("VF{");
    char done = vecfont_draw_letters (&vecfont);
    printf (" =%d, text=%p.%c}\n", done, text, *texxt);
}

void init (void)
{
    FLAGS = 0;
    sys.bootlevel = BOOT_DONE;
    menu.item.onPixel = onPixel;
    count.sec.schoner = 1;
    FLAGS &= ~BEAM_LOCKED;
    FLAGS |= BEAM_VALID;
    
    vecfont_reset (& vecfont);
    vecfont.beam_skip = beam_skip;
    vecfont.beam_xy   = beam_xy;
}


int main (int argc, char *argv[])
{
    init();
    
    printf ("\nHallo \"%s\"!, text=%p\n", argv[0], text);
    
    for (int i=0; i < 40; i++)
    {
        pixel_on_the_fly();
        printf ("-- %d,%d  %d\n", dac.x, dac.y, PORT_Z);
    }
    
    return 0;
}
