/*
    This file is part of MORPHEUS.

    MORPHEUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License (LGPL)
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    MORPHEUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License at <http://www.gnu.org/licenses/>
    for more details.

    (C) Georg-Johann Lay <georgjohann@web.de>
*/

#ifndef TEXT_H
#define TEXT_H

#include <inttypes.h>

#include "pixel.h"

typedef struct text_t
{
    const char * pstr;
    uint8_t textid;
    uint8_t proportional;
    uint8_t zoom;
    uint8_t text_in_flash;
    upixel8_t start;
} text_t;

extern text_t text;

#define TEXT_LEN  20

typedef struct
{
    text_t text[2];
    
    char str[TEXT_LEN];
} text_frame_t;


#include "menu.h"
#include <stdint.h>

extern const menuitem_t menuitem_text;
extern void onPixel_text (text_t*,text_frame_t*);

#endif /* TEXT_H */

